Zu Hauptinhalt wechseln

Dieser Browser wird nicht mehr unterstützt.

Führen Sie ein Upgrade auf Microsoft Edge durch, um die neuesten Features, Sicherheitsupdates und den technischen Support zu nutzen.

Microsoft Edge herunterladen Weitere Informationen zu Internet Explorer und Microsoft Edge
microsoft-foundry.rest.security.o-auth2-auth

Responses

Create a model response

POST /openai/v1/responses

Creates a model response. Provide text or image inputs to generate text or JSON outputs. Have the model call your own custom code or use built-in tools like web search or file search to use your own data as input for the model’s response.

Headerparameter

x-ms-user-identity string

Opaque per-user identity string used to scope endpoint-scoped data to a specific end user. The caller must have the agents/endpoints/UserIdentityImpersonation/action RBAC permission.

x-ms-session-id string

An opaque, application-owned conversation identifier. The value is not returned in the response and must not contain secrets or personally identifiable information.

Anforderungstext

Content-Type: application/json
metadata OpenAI.Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

[key: string] string
top_logprobs integer | null
temperature number | null
top_p number | null
user string | null

This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.

safety_identifier string | null
prompt_cache_key string | null
prompt_cache_retention enum
in_memory24h
previous_response_id string | null
model string

The model deployment to use for the creation of this response.

background boolean | null
max_tool_calls integer | null
text OpenAI.ResponseTextParam

Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs

format json_schema | text | json_object

An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.

Eins der folgenden:
json_schema OpenAI.TextResponseFormatJsonSchema

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

type enum Erforderlich

The type of response format being defined. Always json_schema.

json_schema
description string

A description of what the response format is for, used by the model to determine how to respond in the format.

name string Erforderlich

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

schema OpenAI.ResponseFormatJsonSchemaSchema Erforderlich

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict boolean | null
text OpenAI.TextResponseFormatConfigurationResponseFormatText

Default response format. Used to generate text responses.

type enum Erforderlich

The type of response format being defined. Always text.

text
json_object OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type enum Erforderlich

The type of response format being defined. Always json_object.

json_object
verbosity enum

Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.

lowmediumhigh
tools OpenAI.Tool[]

An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.

tool_choice enum | OpenAI.ToolChoiceParam
Eins der folgenden:
enum

Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.

noneautorequired
Eins der folgenden:
function OpenAI.ToolChoiceFunction

Use this option to force the model to call a specific function.

type enum Erforderlich

For function calling, the type is always function.

function
name string Erforderlich

The name of the function to call.

mcp OpenAI.ToolChoiceMCP

Use this option to force the model to call a specific tool on a remote MCP server.

type enum Erforderlich

For MCP tools, the type is always mcp.

mcp
server_label string Erforderlich

The label of the MCP server to use.

name string | null
allowed_tools OpenAI.ToolChoiceAllowed

Constrains the tools available to the model to a pre-defined set.

type enum Erforderlich

Allowed tool configuration type. Always allowed_tools.

allowed_tools
mode enum Erforderlich

Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.

autorequired
tools object[] Erforderlich

A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]

custom OpenAI.ToolChoiceCustom

Use this option to force the model to call a specific custom tool.

type enum Erforderlich

For custom tool calling, the type is always custom.

custom
name string Erforderlich

The name of the custom tool to call.

programmatic_tool_calling OpenAI.SpecificProgrammaticToolCallingParam
type enum Erforderlich

The tool to call. Always programmatic_tool_calling.

programmatic_tool_calling
apply_patch OpenAI.SpecificApplyPatchParam

Forces the model to call the apply_patch tool when executing a tool call.

type enum Erforderlich

The tool to call. Always apply_patch.

apply_patch
shell OpenAI.SpecificFunctionShellParam

Forces the model to call the shell tool when a tool call is required.

type enum Erforderlich

The tool to call. Always shell.

shell
file_search OpenAI.ToolChoiceFileSearch

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
file_search
web_search_preview OpenAI.ToolChoiceWebSearchPreview

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
web_search_preview
computer_use_preview OpenAI.ToolChoiceComputerUsePreview

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer_use_preview
web_search_preview_2025_03_11 OpenAI.ToolChoiceWebSearchPreview20250311

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
web_search_preview_2025_03_11
image_generation OpenAI.ToolChoiceImageGeneration

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
image_generation
code_interpreter OpenAI.ToolChoiceCodeInterpreter

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
code_interpreter
computer OpenAI.ToolChoiceComputer

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer
computer_use OpenAI.ToolChoiceComputerUse

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer_use
prompt OpenAI.Prompt

Reference to a prompt template and its variables. Learn more.

id string Erforderlich

The unique identifier of the prompt template to use.

version string | null
variables OpenAI.ResponsePromptVariables | null

Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.

[key: string] string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
Eines der folgenden Elemente:
string
type enum Erforderlich

The type of the input item. Always input_text.

input_text
text string Erforderlich

The text input to the model.

prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
type enum Erforderlich

The type of the input item. Always input_image.

input_image
image_url string | null
file_id string | null
detail enum Erforderlich
lowhighautooriginal
prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
type enum Erforderlich

The type of the input item. Always input_file.

input_file
file_id string | null
filename string

The name of the file to be sent to the model.

file_data string

The content of the file to be sent to the model.

prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
file_url string

The URL of the file to be sent to the model.

detail enum
autolowhigh
access_programs OpenAI.AccessProgramsParam

Domain-specific access programs to use for this request.

cyber enum
standarddaybreak_bluedaybreak_red
prompt_cache_options OpenAI.ResponsePromptCacheOptionsParam

Options for prompt caching. Supported for gpt-5.6 and later models. By default, OpenAI automatically chooses one implicit cache breakpoint. You can add explicit breakpoints to content blocks with prompt_cache_breakpoint. Each request can write up to four breakpoints. For cache matching, OpenAI considers up to the latest 80 breakpoints in the conversation, without a content-block lookback limit. Set mode to explicit to disable the implicit breakpoint. The ttl defaults to 30m, which is currently the only supported value. See the prompt caching guide for current details.

ttl enum
30m
mode enum
implicitexplicit
prewarm boolean

Prepares the prompt cache without generating output. Defaults to false. When set to true, overrides the generate field to false.

comparison_response_id string | null
service_tier enum

Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

autodefaultflexscalepriorityfastultrafast
truncation enum
autodisabled
reasoning OpenAI.Reasoning | null

Configuration options for reasoning models.

mode string | enum
Eines der folgenden Elemente:
string
enum
standardpro
effort string | enum | null

Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.

Eines der folgenden Elemente:
string
enum
noneminimallowmediumhighxhighmax
summary enum
autoconcisedetailed
context enum
autocurrent_turnall_turns
generate_summary enum
autoconcisedetailed
input string | OpenAI.InputItem[]

Text, image, or file inputs to the model, used to generate a response. Learn more: - Text inputs and outputs - Image inputs - File inputs - Conversation state - Function calling

Eins der folgenden:
string
OpenAI.InputItem[]
include OpenAI.IncludeEnum[] | null
parallel_tool_calls boolean | null
store boolean | null
instructions string | null
moderation OpenAI.ModerationParam | null

Configuration for running moderation on the input and output of this response.

model string Erforderlich

The moderation model to use for moderated completions, e.g. 'omni-moderation-latest'.

policy OpenAI.ModerationPolicyParam | null

The policy to apply to moderated response input and output.

input OpenAI.ModerationConfigParam | null

The moderation policy for the response input.

mode enum Erforderlich
scoreblock
output OpenAI.ModerationConfigParam | null

The moderation policy for the response input.

mode enum Erforderlich
scoreblock
stream boolean | null
stream_options OpenAI.ResponseStreamOptions | null

Options for streaming responses. Only set this when you set stream: true.

include_obfuscation boolean

When true, stream obfuscation will be enabled. Stream obfuscation adds random characters to an obfuscation field on streaming delta events to normalize payload sizes as a mitigation to certain side-channel attacks. These obfuscation fields are included by default, but add a small amount of overhead to the data stream. You can set include_obfuscation to false to optimize for bandwidth if you trust the network links between your application and the OpenAI API.

conversation string | OpenAI.ConversationParam-2 | null

The conversation that this response belongs to. Items from this conversation are prepended to input_items for this response request. Input items and output items from this response are automatically added to this conversation after this response completes.

Eins der folgenden:
string
id string Erforderlich

The unique ID of the conversation.

context_management OpenAI.ContextManagementParam[] | null

Context management configuration for this request.

max_output_tokens integer | null
agent_session_id string

Optional session identifier for sandbox affinity. Currently only relevant for hosted agents. When provided, the request is routed to the same sandbox. When omitted, auto-derived from conversation_id/prev_response_id or a new UUID is generated.

agent_reference AgentReference
type enum Erforderlich
agent_reference
name string Erforderlich

The name of the agent.

version string

The version identifier of the agent.

structured_inputs object

The structured inputs to the response that can participate in prompt template substitution or tool argument bindings.

user_security_context AzureUserSecurityContext

User security context contains several parameters that describe the application itself, and the end user that interacts with the application. These fields assist your security operations teams to investigate and mitigate security incidents by providing a comprehensive approach to protecting your AI applications. Learn more about protecting AI applications using Microsoft Defender for Cloud.

application_name string

The name of the application. Sensitive personal information should not be included in this field.

end_user_id string

This identifier is the Microsoft Entra ID (formerly Azure Active Directory) user object ID used to authenticate end-users within the generative AI application. Sensitive personal information should not be included in this field.

end_user_tenant_id string

The Microsoft 365 tenant ID the end user belongs to. It's required when the generative AI application is multitenant.

source_ip string

Captures the original client's IP address.

routing_config RoutingConfiguration

Per-request configuration for Model Router inference calls. Supported on Model Router endpoints (deployed or instant if supported). Returns a 400 (Bad Request) error when the target is not a Model Router endpoint.

session_affinity SessionAffinityConfiguration

Request settings that control Model Router session affinity.

mode enum

Request modes supported by Model Router session affinity.

stickynone
session_id string

An opaque, application-owned conversation identifier. Use the same value for related requests. The value is not returned in the response and must not contain secrets or personally identifiable information.

Antworten

The request has succeeded.

Header

x-agent-session-id string

Session ID for this request. Only present for hosted agent responses. Returns the provided session ID or an auto-generated one if not provided in the request.

Text

Content-Type: application/json
metadata OpenAI.Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

[key: string] string
top_logprobs integer | null
temperature number | null
top_p number | null
user string | null

This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.

safety_identifier string | null
prompt_cache_key string | null
prompt_cache_retention enum
in_memory24h
previous_response_id string | null
model string

The model deployment to use for the creation of this response.

background boolean | null
max_tool_calls integer | null
text OpenAI.ResponseTextParam

Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs

format json_schema | text | json_object

An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.

Eins der folgenden:
json_schema OpenAI.TextResponseFormatJsonSchema

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

type enum Erforderlich

The type of response format being defined. Always json_schema.

json_schema
description string

A description of what the response format is for, used by the model to determine how to respond in the format.

name string Erforderlich

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

schema OpenAI.ResponseFormatJsonSchemaSchema Erforderlich

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict boolean | null
text OpenAI.TextResponseFormatConfigurationResponseFormatText

Default response format. Used to generate text responses.

type enum Erforderlich

The type of response format being defined. Always text.

text
json_object OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type enum Erforderlich

The type of response format being defined. Always json_object.

json_object
verbosity enum

Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.

lowmediumhigh
tools OpenAI.Tool[]

An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.

tool_choice enum | OpenAI.ToolChoiceParam
Eins der folgenden:
enum

Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.

noneautorequired
Eins der folgenden:
function OpenAI.ToolChoiceFunction

Use this option to force the model to call a specific function.

type enum Erforderlich

For function calling, the type is always function.

function
name string Erforderlich

The name of the function to call.

mcp OpenAI.ToolChoiceMCP

Use this option to force the model to call a specific tool on a remote MCP server.

type enum Erforderlich

For MCP tools, the type is always mcp.

mcp
server_label string Erforderlich

The label of the MCP server to use.

name string | null
allowed_tools OpenAI.ToolChoiceAllowed

Constrains the tools available to the model to a pre-defined set.

type enum Erforderlich

Allowed tool configuration type. Always allowed_tools.

allowed_tools
mode enum Erforderlich

Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.

autorequired
tools object[] Erforderlich

A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]

custom OpenAI.ToolChoiceCustom

Use this option to force the model to call a specific custom tool.

type enum Erforderlich

For custom tool calling, the type is always custom.

custom
name string Erforderlich

The name of the custom tool to call.

programmatic_tool_calling OpenAI.SpecificProgrammaticToolCallingParam
type enum Erforderlich

The tool to call. Always programmatic_tool_calling.

programmatic_tool_calling
apply_patch OpenAI.SpecificApplyPatchParam

Forces the model to call the apply_patch tool when executing a tool call.

type enum Erforderlich

The tool to call. Always apply_patch.

apply_patch
shell OpenAI.SpecificFunctionShellParam

Forces the model to call the shell tool when a tool call is required.

type enum Erforderlich

The tool to call. Always shell.

shell
file_search OpenAI.ToolChoiceFileSearch

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
file_search
web_search_preview OpenAI.ToolChoiceWebSearchPreview

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
web_search_preview
computer_use_preview OpenAI.ToolChoiceComputerUsePreview

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer_use_preview
web_search_preview_2025_03_11 OpenAI.ToolChoiceWebSearchPreview20250311

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
web_search_preview_2025_03_11
image_generation OpenAI.ToolChoiceImageGeneration

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
image_generation
code_interpreter OpenAI.ToolChoiceCodeInterpreter

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
code_interpreter
computer OpenAI.ToolChoiceComputer

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer
computer_use OpenAI.ToolChoiceComputerUse

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer_use
prompt OpenAI.Prompt

Reference to a prompt template and its variables. Learn more.

id string Erforderlich

The unique identifier of the prompt template to use.

version string | null
variables OpenAI.ResponsePromptVariables | null

Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.

[key: string] string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
Eines der folgenden Elemente:
string
type enum Erforderlich

The type of the input item. Always input_text.

input_text
text string Erforderlich

The text input to the model.

prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
type enum Erforderlich

The type of the input item. Always input_image.

input_image
image_url string | null
file_id string | null
detail enum Erforderlich
lowhighautooriginal
prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
type enum Erforderlich

The type of the input item. Always input_file.

input_file
file_id string | null
filename string

The name of the file to be sent to the model.

file_data string

The content of the file to be sent to the model.

prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
file_url string

The URL of the file to be sent to the model.

detail enum
autolowhigh
service_tier enum

Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

autodefaultflexscalepriorityfastultrafast
truncation enum
autodisabled
id string Erforderlich

Unique identifier for this Response.

object enum Erforderlich

The object type of this resource - always set to response.

response
status enum

The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.

completedfailedin_progresscancelledqueuedincomplete
access_programs OpenAI.AccessProgramsBody | null Erforderlich
cyber enum Erforderlich
standarddaybreak_bluedaybreak_red
created_at integer Erforderlich

Unix timestamp (in seconds) of when this Response was created.

completed_at integer | null
error OpenAI.ResponseError | null Erforderlich

An error object returned when the model fails to generate a Response.

type string | null

The original error type, or null if it was not recorded.

param string | null

The request parameter associated with the error, or null if none was recorded.

code enum Erforderlich

The error code for the response.

server_errorrate_limit_exceededinvalid_promptdata_residency_mismatchbio_policymisalignment_policy_violationvector_store_timeoutinvalid_imageinvalid_image_formatinvalid_base64_imageinvalid_image_urlimage_too_largeimage_too_smallimage_parse_errorimage_content_policy_violationinvalid_image_modeimage_file_too_largeunsupported_image_media_typeempty_image_filefailed_to_download_imageimage_file_not_found
message string Erforderlich

A human-readable description of the error.

misalignment OpenAI.MisalignmentErrorDetailsResource
review_target string | null
error_type string | enum
Eines der folgenden Elemente:
string
enum
potentially_unintended_data_transferpotentially_unintended_data_accesspotentially_unintended_destructive_activityother
detailed_explanation string

The public explanation for this block.

steer OpenAI._MisalignmentSteer
message string Erforderlich

The public continuation instruction.

incomplete_details OpenAI.ResponseIncompleteDetails | null Erforderlich
reason enum
max_output_tokensmax_messagescontent_filtersteered
output OpenAI.OutputItem[] Erforderlich

An array of content items generated by the model. - The length and order of items in the output array is dependent on the model's response. - Rather than accessing the first item in the output array and assuming it's an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.

reasoning OpenAI.Reasoning | null

Configuration options for reasoning models.

mode string | enum
Eines der folgenden Elemente:
string
enum
standardpro
effort string | enum | null

Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.

Eines der folgenden Elemente:
string
enum
noneminimallowmediumhighxhighmax
summary enum
autoconcisedetailed
context enum
autocurrent_turnall_turns
generate_summary enum
autoconcisedetailed
instructions string | OpenAI.InputItem[] | null Erforderlich
Eines der folgenden Elemente:
string
OpenAI.InputItem[]
output_text string | null
usage OpenAI.ResponseUsage | null

Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.

input_tokens integer Erforderlich
input_tokens_details OpenAI.ResponseUsageInputTokensDetails Erforderlich
cached_tokens integer Erforderlich
cache_write_tokens integer Erforderlich
output_tokens integer Erforderlich
output_tokens_details OpenAI.ResponseUsageOutputTokensDetails Erforderlich
reasoning_tokens integer Erforderlich
total_tokens integer Erforderlich
prompt_cache_options OpenAI.PromptCacheOptions

The prompt-caching options that were applied to the response. Supported for gpt-5.6 and later models.

ttl enum Erforderlich
30m
mode enum Erforderlich
implicitexplicit
comparison_response_id string | null
prompt_cache_diagnostics cache_miss | cache_hit | comparison_response_not_found | unavailable

Prompt cache diagnostics requested for this response.

Eins der folgenden:
cache_miss OpenAI.PromptCacheMissDiagnosticsBody
type enum Erforderlich
cache_miss
reason enum Erforderlich
model_changedprompt_cache_key_changedtools_changedtext_format_changedreasoning_effort_changedverbosity_changedcontext_compactedinput_changedservice_tier_changed
cache_missed_tokens integer Erforderlich
comparison_reusable_tokens integer
cache_hit OpenAI.PromptCacheHitDiagnosticsBody
type enum Erforderlich
cache_hit
comparison_response_not_found OpenAI.PromptCacheComparisonResponseNotFoundDiagnosticsBody
type enum Erforderlich
comparison_response_not_found
unavailable OpenAI.PromptCacheUnavailableDiagnosticsBody
type enum Erforderlich
unavailable
moderation OpenAI.Moderation | null

Moderation results or errors for the response input and output.

input error | moderation_result Erforderlich

Moderation results or an error for a response moderation check.

Eins der folgenden:
error OpenAI.ModerationErrorBody

An error produced while attempting moderation for the response input or output.

type enum Erforderlich

The object type, which was always error for moderation failures.

error
code string Erforderlich

The error code.

message string Erforderlich

The error message.

moderation_result OpenAI.ModerationResultBody

A moderation result produced for the response input or output.

type enum Erforderlich

The object type, which was always moderation_result for successful moderation results.

moderation_result
model string Erforderlich

The moderation model that produced this result.

flagged boolean Erforderlich

A boolean indicating whether the content was flagged by any category.

categories object Erforderlich

A dictionary of moderation categories to booleans, True if the input is flagged under this category.

[key: string] boolean
category_scores object Erforderlich

A dictionary of moderation categories to scores.

[key: string] number
category_applied_input_types object Erforderlich

Which modalities of input are reflected by the score for each category.

[key: string] enum[]
output error | moderation_result Erforderlich

Moderation results or an error for a response moderation check.

Eins der folgenden:
error OpenAI.ModerationErrorBody

An error produced while attempting moderation for the response input or output.

type enum Erforderlich

The object type, which was always error for moderation failures.

error
code string Erforderlich

The error code.

message string Erforderlich

The error message.

moderation_result OpenAI.ModerationResultBody

A moderation result produced for the response input or output.

type enum Erforderlich

The object type, which was always moderation_result for successful moderation results.

moderation_result
model string Erforderlich

The moderation model that produced this result.

flagged boolean Erforderlich

A boolean indicating whether the content was flagged by any category.

categories object Erforderlich

A dictionary of moderation categories to booleans, True if the input is flagged under this category.

[key: string] boolean
category_scores object Erforderlich

A dictionary of moderation categories to scores.

[key: string] number
category_applied_input_types object Erforderlich

Which modalities of input are reflected by the score for each category.

[key: string] enum[]
parallel_tool_calls boolean Erforderlich

Whether to allow the model to run tool calls in parallel.

conversation OpenAI.ResponseConversation | null

The conversation that this response belonged to. Input items and output items from this response were automatically added to this conversation.

id string Erforderlich

The unique ID of the conversation that this response was associated with.

max_output_tokens integer | null
agent_reference AgentReference | null Erforderlich

The agent used for this response

type enum Erforderlich
agent_reference
name string Erforderlich

The name of the agent.

version string

The version identifier of the agent.

model_selection_details ModelSelectionDetails

Model selection metadata providing visibility into routing decisions.

model_router_details ModelRouterDetails Erforderlich

Routing decision metadata from Model Router.

mode string | enum Erforderlich

The routing mode used by Model Router for the request.

Eines der folgenden Elemente:
string
enum
balancedcostquality
session_affinity SessionAffinityDetails

Effective Model Router session affinity metadata for a request.

mode string | enum Erforderlich

Effective modes reported for Model Router session affinity.

Eines der folgenden Elemente:
string
enum
stickynone
source string | enum

Conversation identifier sources supported by Model Router session affinity.

Eines der folgenden Elemente:
string
enum
session_id_payloadsession_id_headernot_availableconversationprevious_response_id
decision string | enum

Final outcomes reported for Model Router session affinity.

Eines der folgenden Elemente:
string
enum
initializeretainswitch
routing_trace RoutingTraceEntry[] Erforderlich

Ordered trace of routing decisions. Contains one entry for Chat Completions, and may contain multiple entries for Responses API or agent scenarios where multiple inference turns occur.

content_filters ContentFilterResult[]

The content filter evaluation results.

Content-Type: text/event-stream
Eines der folgenden Elemente:
type enum Erforderlich

The type of the event. Always response.audio.delta.

response.audio.delta
sequence_number integer Erforderlich
delta string Erforderlich

A chunk of Base64 encoded response audio bytes.

type enum Erforderlich

The type of the event. Always response.audio.transcript.delta.

response.audio.transcript.delta
delta string Erforderlich

The partial transcript of the audio response.

sequence_number integer Erforderlich
type enum Erforderlich

The type of the event. Always response.code_interpreter_call_code.delta.

response.code_interpreter_call_code.delta
output_index integer Erforderlich
item_id string Erforderlich

The unique identifier of the code interpreter tool call item.

delta string Erforderlich

The partial code snippet being streamed by the code interpreter.

sequence_number integer Erforderlich
type enum Erforderlich

The type of the event. Always response.code_interpreter_call.in_progress.

response.code_interpreter_call.in_progress
output_index integer Erforderlich
item_id string Erforderlich

The unique identifier of the code interpreter tool call item.

sequence_number integer Erforderlich
type enum Erforderlich

The type of the event. Always response.code_interpreter_call.interpreting.

response.code_interpreter_call.interpreting
output_index integer Erforderlich
item_id string Erforderlich

The unique identifier of the code interpreter tool call item.

sequence_number integer Erforderlich
type enum Erforderlich

The type of the event. Always response.content_part.added.

response.content_part.added
item_id string Erforderlich

The ID of the output item that the content part was added to.

output_index integer Erforderlich
content_index integer Erforderlich
part output_text | refusal | reasoning_text Erforderlich
Eins der folgenden:
output_text OpenAI.OutputContentOutputTextContent

A text output from the model.

type enum Erforderlich

The type of the output text. Always output_text.

output_text
text string Erforderlich

The text output from the model.

annotations OpenAI.Annotation[]

The annotations of the text output.

logprobs OpenAI.LogProb[]
refusal OpenAI.OutputContentRefusalContent

A refusal from the model.

type enum Erforderlich

The type of the refusal. Always refusal.

refusal
refusal string Erforderlich

The refusal explanation from the model.

reasoning_text OpenAI.OutputContentReasoningTextContent

Reasoning text from the model.

type enum Erforderlich

The type of the reasoning text. Always reasoning_text.

reasoning_text
text string Erforderlich

The reasoning text from the model.

sequence_number integer Erforderlich
type enum Erforderlich

The type of the event. Always response.created.

response.created
response OpenAI.Response Erforderlich
metadata OpenAI.Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

[key: string] string
top_logprobs integer | null
temperature number | null
top_p number | null
user string | null

This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.

safety_identifier string | null
prompt_cache_key string | null
prompt_cache_retention enum
in_memory24h
previous_response_id string | null
model string

The model deployment to use for the creation of this response.

background boolean | null
max_tool_calls integer | null
text OpenAI.ResponseTextParam

Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs

format json_schema | text | json_object

An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.

Eins der folgenden:
json_schema OpenAI.TextResponseFormatJsonSchema

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

type enum Erforderlich

The type of response format being defined. Always json_schema.

json_schema
description string

A description of what the response format is for, used by the model to determine how to respond in the format.

name string Erforderlich

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

schema OpenAI.ResponseFormatJsonSchemaSchema Erforderlich

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict boolean | null
text OpenAI.TextResponseFormatConfigurationResponseFormatText

Default response format. Used to generate text responses.

type enum Erforderlich

The type of response format being defined. Always text.

text
json_object OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type enum Erforderlich

The type of response format being defined. Always json_object.

json_object
verbosity enum

Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.

lowmediumhigh
tools OpenAI.Tool[]

An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.

tool_choice enum | OpenAI.ToolChoiceParam
Eins der folgenden:
enum

Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.

noneautorequired
Eins der folgenden:
function OpenAI.ToolChoiceFunction

Use this option to force the model to call a specific function.

type enum Erforderlich

For function calling, the type is always function.

function
name string Erforderlich

The name of the function to call.

mcp OpenAI.ToolChoiceMCP

Use this option to force the model to call a specific tool on a remote MCP server.

type enum Erforderlich

For MCP tools, the type is always mcp.

mcp
server_label string Erforderlich

The label of the MCP server to use.

name string | null
allowed_tools OpenAI.ToolChoiceAllowed

Constrains the tools available to the model to a pre-defined set.

type enum Erforderlich

Allowed tool configuration type. Always allowed_tools.

allowed_tools
mode enum Erforderlich

Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.

autorequired
tools object[] Erforderlich

A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]

custom OpenAI.ToolChoiceCustom

Use this option to force the model to call a specific custom tool.

type enum Erforderlich

For custom tool calling, the type is always custom.

custom
name string Erforderlich

The name of the custom tool to call.

programmatic_tool_calling OpenAI.SpecificProgrammaticToolCallingParam
type enum Erforderlich

The tool to call. Always programmatic_tool_calling.

programmatic_tool_calling
apply_patch OpenAI.SpecificApplyPatchParam

Forces the model to call the apply_patch tool when executing a tool call.

type enum Erforderlich

The tool to call. Always apply_patch.

apply_patch
shell OpenAI.SpecificFunctionShellParam

Forces the model to call the shell tool when a tool call is required.

type enum Erforderlich

The tool to call. Always shell.

shell
file_search OpenAI.ToolChoiceFileSearch

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
file_search
web_search_preview OpenAI.ToolChoiceWebSearchPreview

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
web_search_preview
computer_use_preview OpenAI.ToolChoiceComputerUsePreview

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer_use_preview
web_search_preview_2025_03_11 OpenAI.ToolChoiceWebSearchPreview20250311

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
web_search_preview_2025_03_11
image_generation OpenAI.ToolChoiceImageGeneration

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
image_generation
code_interpreter OpenAI.ToolChoiceCodeInterpreter

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
code_interpreter
computer OpenAI.ToolChoiceComputer

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer
computer_use OpenAI.ToolChoiceComputerUse

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer_use
prompt OpenAI.Prompt

Reference to a prompt template and its variables. Learn more.

id string Erforderlich

The unique identifier of the prompt template to use.

version string | null
variables OpenAI.ResponsePromptVariables | null

Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.

[key: string] string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
Eines der folgenden Elemente:
string
type enum Erforderlich

The type of the input item. Always input_text.

input_text
text string Erforderlich

The text input to the model.

prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
type enum Erforderlich

The type of the input item. Always input_image.

input_image
image_url string | null
file_id string | null
detail enum Erforderlich
lowhighautooriginal
prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
type enum Erforderlich

The type of the input item. Always input_file.

input_file
file_id string | null
filename string

The name of the file to be sent to the model.

file_data string

The content of the file to be sent to the model.

prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
file_url string

The URL of the file to be sent to the model.

detail enum
autolowhigh
service_tier enum

Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

autodefaultflexscalepriorityfastultrafast
truncation enum
autodisabled
id string Erforderlich

Unique identifier for this Response.

object enum Erforderlich

The object type of this resource - always set to response.

response
status enum

The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.

completedfailedin_progresscancelledqueuedincomplete
access_programs OpenAI.AccessProgramsBody | null Erforderlich
cyber enum Erforderlich
standarddaybreak_bluedaybreak_red
created_at integer Erforderlich

Unix timestamp (in seconds) of when this Response was created.

completed_at integer | null
error OpenAI.ResponseError | null Erforderlich

An error object returned when the model fails to generate a Response.

type string | null

The original error type, or null if it was not recorded.

param string | null

The request parameter associated with the error, or null if none was recorded.

code enum Erforderlich

The error code for the response.

server_errorrate_limit_exceededinvalid_promptdata_residency_mismatchbio_policymisalignment_policy_violationvector_store_timeoutinvalid_imageinvalid_image_formatinvalid_base64_imageinvalid_image_urlimage_too_largeimage_too_smallimage_parse_errorimage_content_policy_violationinvalid_image_modeimage_file_too_largeunsupported_image_media_typeempty_image_filefailed_to_download_imageimage_file_not_found
message string Erforderlich

A human-readable description of the error.

misalignment OpenAI.MisalignmentErrorDetailsResource
review_target string | null
error_type string | enum
Eines der folgenden Elemente:
string
enum
potentially_unintended_data_transferpotentially_unintended_data_accesspotentially_unintended_destructive_activityother
detailed_explanation string

The public explanation for this block.

steer OpenAI._MisalignmentSteer
message string Erforderlich

The public continuation instruction.

incomplete_details OpenAI.ResponseIncompleteDetails | null Erforderlich
reason enum
max_output_tokensmax_messagescontent_filtersteered
output OpenAI.OutputItem[] Erforderlich

An array of content items generated by the model. - The length and order of items in the output array is dependent on the model's response. - Rather than accessing the first item in the output array and assuming it's an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.

reasoning OpenAI.Reasoning | null

Configuration options for reasoning models.

mode string | enum
Eines der folgenden Elemente:
string
enum
standardpro
effort string | enum | null

Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.

Eines der folgenden Elemente:
string
enum
noneminimallowmediumhighxhighmax
summary enum
autoconcisedetailed
context enum
autocurrent_turnall_turns
generate_summary enum
autoconcisedetailed
instructions string | OpenAI.InputItem[] | null Erforderlich
Eines der folgenden Elemente:
string
OpenAI.InputItem[]
output_text string | null
usage OpenAI.ResponseUsage | null

Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.

input_tokens integer Erforderlich
input_tokens_details OpenAI.ResponseUsageInputTokensDetails Erforderlich
cached_tokens integer Erforderlich
cache_write_tokens integer Erforderlich
output_tokens integer Erforderlich
output_tokens_details OpenAI.ResponseUsageOutputTokensDetails Erforderlich
reasoning_tokens integer Erforderlich
total_tokens integer Erforderlich
prompt_cache_options OpenAI.PromptCacheOptions

The prompt-caching options that were applied to the response. Supported for gpt-5.6 and later models.

ttl enum Erforderlich
30m
mode enum Erforderlich
implicitexplicit
comparison_response_id string | null
prompt_cache_diagnostics cache_miss | cache_hit | comparison_response_not_found | unavailable

Prompt cache diagnostics requested for this response.

Eins der folgenden:
cache_miss OpenAI.PromptCacheMissDiagnosticsBody
type enum Erforderlich
cache_miss
reason enum Erforderlich
model_changedprompt_cache_key_changedtools_changedtext_format_changedreasoning_effort_changedverbosity_changedcontext_compactedinput_changedservice_tier_changed
cache_missed_tokens integer Erforderlich
comparison_reusable_tokens integer
cache_hit OpenAI.PromptCacheHitDiagnosticsBody
type enum Erforderlich
cache_hit
comparison_response_not_found OpenAI.PromptCacheComparisonResponseNotFoundDiagnosticsBody
type enum Erforderlich
comparison_response_not_found
unavailable OpenAI.PromptCacheUnavailableDiagnosticsBody
type enum Erforderlich
unavailable
moderation OpenAI.Moderation | null

Moderation results or errors for the response input and output.

input error | moderation_result Erforderlich

Moderation results or an error for a response moderation check.

Eins der folgenden:
error OpenAI.ModerationErrorBody

An error produced while attempting moderation for the response input or output.

type enum Erforderlich

The object type, which was always error for moderation failures.

error
code string Erforderlich

The error code.

message string Erforderlich

The error message.

moderation_result OpenAI.ModerationResultBody

A moderation result produced for the response input or output.

type enum Erforderlich

The object type, which was always moderation_result for successful moderation results.

moderation_result
model string Erforderlich

The moderation model that produced this result.

flagged boolean Erforderlich

A boolean indicating whether the content was flagged by any category.

categories object Erforderlich

A dictionary of moderation categories to booleans, True if the input is flagged under this category.

[key: string] boolean
category_scores object Erforderlich

A dictionary of moderation categories to scores.

[key: string] number
category_applied_input_types object Erforderlich

Which modalities of input are reflected by the score for each category.

[key: string] enum[]
output error | moderation_result Erforderlich

Moderation results or an error for a response moderation check.

Eins der folgenden:
error OpenAI.ModerationErrorBody

An error produced while attempting moderation for the response input or output.

type enum Erforderlich

The object type, which was always error for moderation failures.

error
code string Erforderlich

The error code.

message string Erforderlich

The error message.

moderation_result OpenAI.ModerationResultBody

A moderation result produced for the response input or output.

type enum Erforderlich

The object type, which was always moderation_result for successful moderation results.

moderation_result
model string Erforderlich

The moderation model that produced this result.

flagged boolean Erforderlich

A boolean indicating whether the content was flagged by any category.

categories object Erforderlich

A dictionary of moderation categories to booleans, True if the input is flagged under this category.

[key: string] boolean
category_scores object Erforderlich

A dictionary of moderation categories to scores.

[key: string] number
category_applied_input_types object Erforderlich

Which modalities of input are reflected by the score for each category.

[key: string] enum[]
parallel_tool_calls boolean Erforderlich

Whether to allow the model to run tool calls in parallel.

conversation OpenAI.ResponseConversation | null

The conversation that this response belonged to. Input items and output items from this response were automatically added to this conversation.

id string Erforderlich

The unique ID of the conversation that this response was associated with.

max_output_tokens integer | null
agent_reference AgentReference | null Erforderlich

The agent used for this response

type enum Erforderlich
agent_reference
name string Erforderlich

The name of the agent.

version string

The version identifier of the agent.

model_selection_details ModelSelectionDetails

Model selection metadata providing visibility into routing decisions.

model_router_details ModelRouterDetails Erforderlich

Routing decision metadata from Model Router.

mode string | enum Erforderlich

The routing mode used by Model Router for the request.

Eines der folgenden Elemente:
string
enum
balancedcostquality
session_affinity SessionAffinityDetails

Effective Model Router session affinity metadata for a request.

mode string | enum Erforderlich

Effective modes reported for Model Router session affinity.

Eines der folgenden Elemente:
string
enum
stickynone
source string | enum

Conversation identifier sources supported by Model Router session affinity.

Eines der folgenden Elemente:
string
enum
session_id_payloadsession_id_headernot_availableconversationprevious_response_id
decision string | enum

Final outcomes reported for Model Router session affinity.

Eines der folgenden Elemente:
string
enum
initializeretainswitch
routing_trace RoutingTraceEntry[] Erforderlich

Ordered trace of routing decisions. Contains one entry for Chat Completions, and may contain multiple entries for Responses API or agent scenarios where multiple inference turns occur.

content_filters ContentFilterResult[]

The content filter evaluation results.

sequence_number integer Erforderlich
type enum Erforderlich

The type of the event. Always error.

error
code string | null Erforderlich
message string Erforderlich

The error message.

param string | null Erforderlich
sequence_number integer Erforderlich
type enum Erforderlich

The type of the event. Always response.file_search_call.in_progress.

response.file_search_call.in_progress
output_index integer Erforderlich
item_id string Erforderlich

The ID of the output item that the file search call is initiated.

sequence_number integer Erforderlich
type enum Erforderlich

The type of the event. Always response.file_search_call.searching.

response.file_search_call.searching
output_index integer Erforderlich
item_id string Erforderlich

The ID of the output item that the file search call is initiated.

sequence_number integer Erforderlich
type enum Erforderlich

The type of the event. Always response.function_call_arguments.delta.

response.function_call_arguments.delta
item_id string Erforderlich

The ID of the output item that the function-call arguments delta is added to.

output_index integer Erforderlich
sequence_number integer Erforderlich
delta string Erforderlich

The function-call arguments delta that is added.

type enum Erforderlich

The type of the event. Always response.in_progress.

response.in_progress
response OpenAI.Response Erforderlich
metadata OpenAI.Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

[key: string] string
top_logprobs integer | null
temperature number | null
top_p number | null
user string | null

This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.

safety_identifier string | null
prompt_cache_key string | null
prompt_cache_retention enum
in_memory24h
previous_response_id string | null
model string

The model deployment to use for the creation of this response.

background boolean | null
max_tool_calls integer | null
text OpenAI.ResponseTextParam

Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs

format json_schema | text | json_object

An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.

Eins der folgenden:
json_schema OpenAI.TextResponseFormatJsonSchema

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

type enum Erforderlich

The type of response format being defined. Always json_schema.

json_schema
description string

A description of what the response format is for, used by the model to determine how to respond in the format.

name string Erforderlich

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

schema OpenAI.ResponseFormatJsonSchemaSchema Erforderlich

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict boolean | null
text OpenAI.TextResponseFormatConfigurationResponseFormatText

Default response format. Used to generate text responses.

type enum Erforderlich

The type of response format being defined. Always text.

text
json_object OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type enum Erforderlich

The type of response format being defined. Always json_object.

json_object
verbosity enum

Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.

lowmediumhigh
tools OpenAI.Tool[]

An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.

tool_choice enum | OpenAI.ToolChoiceParam
Eins der folgenden:
enum

Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.

noneautorequired
Eins der folgenden:
function OpenAI.ToolChoiceFunction

Use this option to force the model to call a specific function.

type enum Erforderlich

For function calling, the type is always function.

function
name string Erforderlich

The name of the function to call.

mcp OpenAI.ToolChoiceMCP

Use this option to force the model to call a specific tool on a remote MCP server.

type enum Erforderlich

For MCP tools, the type is always mcp.

mcp
server_label string Erforderlich

The label of the MCP server to use.

name string | null
allowed_tools OpenAI.ToolChoiceAllowed

Constrains the tools available to the model to a pre-defined set.

type enum Erforderlich

Allowed tool configuration type. Always allowed_tools.

allowed_tools
mode enum Erforderlich

Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.

autorequired
tools object[] Erforderlich

A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]

custom OpenAI.ToolChoiceCustom

Use this option to force the model to call a specific custom tool.

type enum Erforderlich

For custom tool calling, the type is always custom.

custom
name string Erforderlich

The name of the custom tool to call.

programmatic_tool_calling OpenAI.SpecificProgrammaticToolCallingParam
type enum Erforderlich

The tool to call. Always programmatic_tool_calling.

programmatic_tool_calling
apply_patch OpenAI.SpecificApplyPatchParam

Forces the model to call the apply_patch tool when executing a tool call.

type enum Erforderlich

The tool to call. Always apply_patch.

apply_patch
shell OpenAI.SpecificFunctionShellParam

Forces the model to call the shell tool when a tool call is required.

type enum Erforderlich

The tool to call. Always shell.

shell
file_search OpenAI.ToolChoiceFileSearch

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
file_search
web_search_preview OpenAI.ToolChoiceWebSearchPreview

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
web_search_preview
computer_use_preview OpenAI.ToolChoiceComputerUsePreview

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer_use_preview
web_search_preview_2025_03_11 OpenAI.ToolChoiceWebSearchPreview20250311

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
web_search_preview_2025_03_11
image_generation OpenAI.ToolChoiceImageGeneration

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
image_generation
code_interpreter OpenAI.ToolChoiceCodeInterpreter

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
code_interpreter
computer OpenAI.ToolChoiceComputer

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer
computer_use OpenAI.ToolChoiceComputerUse

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer_use
prompt OpenAI.Prompt

Reference to a prompt template and its variables. Learn more.

id string Erforderlich

The unique identifier of the prompt template to use.

version string | null
variables OpenAI.ResponsePromptVariables | null

Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.

[key: string] string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
Eines der folgenden Elemente:
string
type enum Erforderlich

The type of the input item. Always input_text.

input_text
text string Erforderlich

The text input to the model.

prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
type enum Erforderlich

The type of the input item. Always input_image.

input_image
image_url string | null
file_id string | null
detail enum Erforderlich
lowhighautooriginal
prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
type enum Erforderlich

The type of the input item. Always input_file.

input_file
file_id string | null
filename string

The name of the file to be sent to the model.

file_data string

The content of the file to be sent to the model.

prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
file_url string

The URL of the file to be sent to the model.

detail enum
autolowhigh
service_tier enum

Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

autodefaultflexscalepriorityfastultrafast
truncation enum
autodisabled
id string Erforderlich

Unique identifier for this Response.

object enum Erforderlich

The object type of this resource - always set to response.

response
status enum

The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.

completedfailedin_progresscancelledqueuedincomplete
access_programs OpenAI.AccessProgramsBody | null Erforderlich
cyber enum Erforderlich
standarddaybreak_bluedaybreak_red
created_at integer Erforderlich

Unix timestamp (in seconds) of when this Response was created.

completed_at integer | null
error OpenAI.ResponseError | null Erforderlich

An error object returned when the model fails to generate a Response.

type string | null

The original error type, or null if it was not recorded.

param string | null

The request parameter associated with the error, or null if none was recorded.

code enum Erforderlich

The error code for the response.

server_errorrate_limit_exceededinvalid_promptdata_residency_mismatchbio_policymisalignment_policy_violationvector_store_timeoutinvalid_imageinvalid_image_formatinvalid_base64_imageinvalid_image_urlimage_too_largeimage_too_smallimage_parse_errorimage_content_policy_violationinvalid_image_modeimage_file_too_largeunsupported_image_media_typeempty_image_filefailed_to_download_imageimage_file_not_found
message string Erforderlich

A human-readable description of the error.

misalignment OpenAI.MisalignmentErrorDetailsResource
review_target string | null
error_type string | enum
Eines der folgenden Elemente:
string
enum
potentially_unintended_data_transferpotentially_unintended_data_accesspotentially_unintended_destructive_activityother
detailed_explanation string

The public explanation for this block.

steer OpenAI._MisalignmentSteer
message string Erforderlich

The public continuation instruction.

incomplete_details OpenAI.ResponseIncompleteDetails | null Erforderlich
reason enum
max_output_tokensmax_messagescontent_filtersteered
output OpenAI.OutputItem[] Erforderlich

An array of content items generated by the model. - The length and order of items in the output array is dependent on the model's response. - Rather than accessing the first item in the output array and assuming it's an assistant message with the content generated by the model, you might consider using the output_text property where supported in SDKs.

reasoning OpenAI.Reasoning | null

Configuration options for reasoning models.

mode string | enum
Eines der folgenden Elemente:
string
enum
standardpro
effort string | enum | null

Constrains effort on reasoning for reasoning models. Currently supported values are none, minimal, low, medium, high, xhigh, and max. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.

Eines der folgenden Elemente:
string
enum
noneminimallowmediumhighxhighmax
summary enum
autoconcisedetailed
context enum
autocurrent_turnall_turns
generate_summary enum
autoconcisedetailed
instructions string | OpenAI.InputItem[] | null Erforderlich
Eines der folgenden Elemente:
string
OpenAI.InputItem[]
output_text string | null
usage OpenAI.ResponseUsage | null

Represents token usage details including input tokens, output tokens, a breakdown of output tokens, and the total tokens used.

input_tokens integer Erforderlich
input_tokens_details OpenAI.ResponseUsageInputTokensDetails Erforderlich
cached_tokens integer Erforderlich
cache_write_tokens integer Erforderlich
output_tokens integer Erforderlich
output_tokens_details OpenAI.ResponseUsageOutputTokensDetails Erforderlich
reasoning_tokens integer Erforderlich
total_tokens integer Erforderlich
prompt_cache_options OpenAI.PromptCacheOptions

The prompt-caching options that were applied to the response. Supported for gpt-5.6 and later models.

ttl enum Erforderlich
30m
mode enum Erforderlich
implicitexplicit
comparison_response_id string | null
prompt_cache_diagnostics cache_miss | cache_hit | comparison_response_not_found | unavailable

Prompt cache diagnostics requested for this response.

Eins der folgenden:
cache_miss OpenAI.PromptCacheMissDiagnosticsBody
type enum Erforderlich
cache_miss
reason enum Erforderlich
model_changedprompt_cache_key_changedtools_changedtext_format_changedreasoning_effort_changedverbosity_changedcontext_compactedinput_changedservice_tier_changed
cache_missed_tokens integer Erforderlich
comparison_reusable_tokens integer
cache_hit OpenAI.PromptCacheHitDiagnosticsBody
type enum Erforderlich
cache_hit
comparison_response_not_found OpenAI.PromptCacheComparisonResponseNotFoundDiagnosticsBody
type enum Erforderlich
comparison_response_not_found
unavailable OpenAI.PromptCacheUnavailableDiagnosticsBody
type enum Erforderlich
unavailable
moderation OpenAI.Moderation | null

Moderation results or errors for the response input and output.

input error | moderation_result Erforderlich

Moderation results or an error for a response moderation check.

Eins der folgenden:
error OpenAI.ModerationErrorBody

An error produced while attempting moderation for the response input or output.

type enum Erforderlich

The object type, which was always error for moderation failures.

error
code string Erforderlich

The error code.

message string Erforderlich

The error message.

moderation_result OpenAI.ModerationResultBody

A moderation result produced for the response input or output.

type enum Erforderlich

The object type, which was always moderation_result for successful moderation results.

moderation_result
model string Erforderlich

The moderation model that produced this result.

flagged boolean Erforderlich

A boolean indicating whether the content was flagged by any category.

categories object Erforderlich

A dictionary of moderation categories to booleans, True if the input is flagged under this category.

[key: string] boolean
category_scores object Erforderlich

A dictionary of moderation categories to scores.

[key: string] number
category_applied_input_types object Erforderlich

Which modalities of input are reflected by the score for each category.

[key: string] enum[]
output error | moderation_result Erforderlich

Moderation results or an error for a response moderation check.

Eins der folgenden:
error OpenAI.ModerationErrorBody

An error produced while attempting moderation for the response input or output.

type enum Erforderlich

The object type, which was always error for moderation failures.

error
code string Erforderlich

The error code.

message string Erforderlich

The error message.

moderation_result OpenAI.ModerationResultBody

A moderation result produced for the response input or output.

type enum Erforderlich

The object type, which was always moderation_result for successful moderation results.

moderation_result
model string Erforderlich

The moderation model that produced this result.

flagged boolean Erforderlich

A boolean indicating whether the content was flagged by any category.

categories object Erforderlich

A dictionary of moderation categories to booleans, True if the input is flagged under this category.

[key: string] boolean
category_scores object Erforderlich

A dictionary of moderation categories to scores.

[key: string] number
category_applied_input_types object Erforderlich

Which modalities of input are reflected by the score for each category.

[key: string] enum[]
parallel_tool_calls boolean Erforderlich

Whether to allow the model to run tool calls in parallel.

conversation OpenAI.ResponseConversation | null

The conversation that this response belonged to. Input items and output items from this response were automatically added to this conversation.

id string Erforderlich

The unique ID of the conversation that this response was associated with.

max_output_tokens integer | null
agent_reference AgentReference | null Erforderlich

The agent used for this response

type enum Erforderlich
agent_reference
name string Erforderlich

The name of the agent.

version string

The version identifier of the agent.

model_selection_details ModelSelectionDetails

Model selection metadata providing visibility into routing decisions.

model_router_details ModelRouterDetails Erforderlich

Routing decision metadata from Model Router.

mode string | enum Erforderlich

The routing mode used by Model Router for the request.

Eines der folgenden Elemente:
string
enum
balancedcostquality
session_affinity SessionAffinityDetails

Effective Model Router session affinity metadata for a request.

mode string | enum Erforderlich

Effective modes reported for Model Router session affinity.

Eines der folgenden Elemente:
string
enum
stickynone
source string | enum

Conversation identifier sources supported by Model Router session affinity.

Eines der folgenden Elemente:
string
enum
session_id_payloadsession_id_headernot_availableconversationprevious_response_id
decision string | enum

Final outcomes reported for Model Router session affinity.

Eines der folgenden Elemente:
string
enum
initializeretainswitch
routing_trace RoutingTraceEntry[] Erforderlich

Ordered trace of routing decisions. Contains one entry for Chat Completions, and may contain multiple entries for Responses API or agent scenarios where multiple inference turns occur.

content_filters ContentFilterResult[]

The content filter evaluation results.

sequence_number integer Erforderlich
type enum Erforderlich

The type of the event. Always response.failed.

response.failed
sequence_number integer Erforderlich
response OpenAI.Response Erforderlich
metadata OpenAI.Metadata | null

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

[key: string] string
top_logprobs integer | null
temperature number | null
top_p number | null
user string | null

This field is being replaced by safety_identifier and prompt_cache_key. Use prompt_cache_key instead to maintain caching optimizations. A stable identifier for your end-users. Used to boost cache hit rates by better bucketing similar requests and to help OpenAI detect and prevent abuse. Learn more.

safety_identifier string | null
prompt_cache_key string | null
prompt_cache_retention enum
in_memory24h
previous_response_id string | null
model string

The model deployment to use for the creation of this response.

background boolean | null
max_tool_calls integer | null
text OpenAI.ResponseTextParam

Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more: - Text inputs and outputs - Structured Outputs

format json_schema | text | json_object

An object specifying the format that the model must output. Configuring { "type": "json_schema" } enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide. The default format is { "type": "text" } with no additional options. Not recommended for gpt-4o and newer models:* Setting to { "type": "json_object" } enables the older JSON mode, which ensures the message the model generates is valid JSON. Using json_schema is preferred for models that support it.

Eins der folgenden:
json_schema OpenAI.TextResponseFormatJsonSchema

JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.

type enum Erforderlich

The type of response format being defined. Always json_schema.

json_schema
description string

A description of what the response format is for, used by the model to determine how to respond in the format.

name string Erforderlich

The name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.

schema OpenAI.ResponseFormatJsonSchemaSchema Erforderlich

The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.

strict boolean | null
text OpenAI.TextResponseFormatConfigurationResponseFormatText

Default response format. Used to generate text responses.

type enum Erforderlich

The type of response format being defined. Always text.

text
json_object OpenAI.TextResponseFormatConfigurationResponseFormatJsonObject

JSON object response format. An older method of generating JSON responses. Using json_schema is recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.

type enum Erforderlich

The type of response format being defined. Always json_object.

json_object
verbosity enum

Constrains the verbosity of the model's response. Lower values will result in more concise responses, while higher values will result in more verbose responses. Currently supported values are low, medium, and high. The default is medium.

lowmediumhigh
tools OpenAI.Tool[]

An array of tools the model may call while generating a response. You can specify which tool to use by setting the tool_choice parameter. We support the following categories of tools: - Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools. - MCP Tools: Integrations with third-party systems via custom MCP servers or predefined connectors such as Google Drive and SharePoint. Learn more about MCP Tools. - Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code with strongly typed arguments and outputs. Learn more about function calling. You can also use custom tools to call your own code.

tool_choice enum | OpenAI.ToolChoiceParam
Eins der folgenden:
enum

Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools.

noneautorequired
Eins der folgenden:
function OpenAI.ToolChoiceFunction

Use this option to force the model to call a specific function.

type enum Erforderlich

For function calling, the type is always function.

function
name string Erforderlich

The name of the function to call.

mcp OpenAI.ToolChoiceMCP

Use this option to force the model to call a specific tool on a remote MCP server.

type enum Erforderlich

For MCP tools, the type is always mcp.

mcp
server_label string Erforderlich

The label of the MCP server to use.

name string | null
allowed_tools OpenAI.ToolChoiceAllowed

Constrains the tools available to the model to a pre-defined set.

type enum Erforderlich

Allowed tool configuration type. Always allowed_tools.

allowed_tools
mode enum Erforderlich

Constrains the tools available to the model to a pre-defined set. auto allows the model to pick from among the allowed tools and generate a message. required requires the model to call one or more of the allowed tools.

autorequired
tools object[] Erforderlich

A list of tool definitions that the model should be allowed to call. For the Responses API, the list of tool definitions might look like: json [ { "type": "function", "name": "get_weather" }, { "type": "mcp", "server_label": "deepwiki" }, { "type": "image_generation" } ]

custom OpenAI.ToolChoiceCustom

Use this option to force the model to call a specific custom tool.

type enum Erforderlich

For custom tool calling, the type is always custom.

custom
name string Erforderlich

The name of the custom tool to call.

programmatic_tool_calling OpenAI.SpecificProgrammaticToolCallingParam
type enum Erforderlich

The tool to call. Always programmatic_tool_calling.

programmatic_tool_calling
apply_patch OpenAI.SpecificApplyPatchParam

Forces the model to call the apply_patch tool when executing a tool call.

type enum Erforderlich

The tool to call. Always apply_patch.

apply_patch
shell OpenAI.SpecificFunctionShellParam

Forces the model to call the shell tool when a tool call is required.

type enum Erforderlich

The tool to call. Always shell.

shell
file_search OpenAI.ToolChoiceFileSearch

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
file_search
web_search_preview OpenAI.ToolChoiceWebSearchPreview

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
web_search_preview
computer_use_preview OpenAI.ToolChoiceComputerUsePreview

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer_use_preview
web_search_preview_2025_03_11 OpenAI.ToolChoiceWebSearchPreview20250311

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
web_search_preview_2025_03_11
image_generation OpenAI.ToolChoiceImageGeneration

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
image_generation
code_interpreter OpenAI.ToolChoiceCodeInterpreter

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
code_interpreter
computer OpenAI.ToolChoiceComputer

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer
computer_use OpenAI.ToolChoiceComputerUse

Indicates that the model should use a built-in tool to generate a response. Learn more about built-in tools.

type enum Erforderlich
computer_use
prompt OpenAI.Prompt

Reference to a prompt template and its variables. Learn more.

id string Erforderlich

The unique identifier of the prompt template to use.

version string | null
variables OpenAI.ResponsePromptVariables | null

Optional map of values to substitute in for variables in your prompt. The substitution values can either be strings, or other Response input types like images or files.

[key: string] string | OpenAI.InputTextContent | OpenAI.InputImageContent | OpenAI.InputFileContent
Eines der folgenden Elemente:
string
type enum Erforderlich

The type of the input item. Always input_text.

input_text
text string Erforderlich

The text input to the model.

prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
type enum Erforderlich

The type of the input item. Always input_image.

input_image
image_url string | null
file_id string | null
detail enum Erforderlich
lowhighautooriginal
prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
type enum Erforderlich

The type of the input item. Always input_file.

input_file
file_id string | null
filename string

The name of the file to be sent to the model.

file_data string

The content of the file to be sent to the model.

prompt_cache_breakpoint OpenAI.PromptCacheBreakpointConfig

Marks the exact end of a reusable prompt prefix. The breakpoint inherits its TTL from the request's prompt_cache_options.ttl; the boundary is not rounded to a token block.

mode enum Erforderlich

The breakpoint mode. Always explicit.

explicit
file_url string

The URL of the file to be sent to the model.

detail enum
autolowhigh
service_tier enum

Specifies the processing type used for serving the request. - If set to 'auto', then the request will be processed with the service tier configured in the Project settings. Unless otherwise configured, the Project will use 'default'. - If set to 'default', then the request will be processed with the standard pricing and performance for the selected model. - If set to 'flex', then the request will be processed with the Flex Processing service tier. - To opt-in to Fast mode at the request level, include the service_tier=fast or service_tier=priority parameter for Responses or Chat Completions. The response will show service_tier=priority regardless of if you specify service_tier=fast or priority in your request. - If set to 'ultrafast', then the request will be processed with the access-controlled Ultrafast Processing service tier. This tier is currently available for gpt-5.6-sol; a response served through it will show service_tier=ultrafast. - When not set, the default behavior is 'auto'. When the service_tier parameter is set, the response body will include the service_tier value based on the processing mode actually used to serve the request. This response value may be different from the value set in the parameter.

autodefaultflexscalepriorityfastultrafast
truncation enum
autodisabled
id string Erforderlich

Unique identifier for this Response.

object enum Erforderlich

The object type of this resource - always set to response.

response
status enum

The status of the response generation. One of completed, failed, in_progress, cancelled, queued, or incomplete.

completedfailedin_progresscancelledqueuedincomplete
access_programs OpenAI.AccessProgramsBody | null Erforderlich
cyber enum Erforderlich
standarddaybreak_bluedaybreak_red
created_at integer Erforderlich

Unix timestamp (in seconds) of when this Response was created.

completed_at integer | null
error OpenAI.ResponseError | null Erforderlich

An error object returned when the model fails to generate a Response.

type string | null

The original error type, or null if it was not recorded.

param string | null

The request parameter associated with the error, or null if none was recorded.

code enum Erforderlich

The error code for the response.

[...]
